#!/usr/bin/env python3
from marshmallow import Schema, fields, RAISE


class ControlConfigurationSchema(Schema):
    robot_address = fields.Str(required=True)
    program_url = fields.Str(required=True)

    class Meta:
        unknown = RAISE


class ControlStatusConfigurationSchema(Schema):
    cluster_ip = fields.IP()
    phase = fields.Str()

    class Meta:
        unknown = RAISE


class ControllerSchema(Schema):
    pod_name = fields.Str(required=False, dump_only=True)
    configuration = fields.Nested(ControlConfigurationSchema, many=False, required=True)
    status = fields.Nested(ControlStatusConfigurationSchema, many=False, required=False, dump_only=True)

    class Meta:
        unknown = RAISE
